#include <iostream>
#include <vector>
#include <map>
#include <cmath>
#include <string>
#include <set>
#include <algorithm>
#include <queue>

using namespace std;

vector<vector<int> > g;
vector<int> used;
int sum = 0;
int cnt;

void dfs(int v){
    cnt++;
    used[v] = 1;
    for (auto to: g[v]){
        if (!used[to])
            dfs(to);
    }
}

int main()
{
    int n;
    cin >> n;
    g.resize(n);
    used.resize(n);
	vector<int> v(n);
    for (int i = 0; i < n; i++){
        int x;
        cin >> x;
        if (x == -1) continue;
        x--;
		v[i] = x;
        g[x].push_back(i);
        g[i].push_back(x);
    }

	vector<int> step(n);
	for (int i = 0; i < n; i++)
		step[v[i]]++;

	for (int i = 0; i < n; i++)
		if (step[i] > 1) used[i] = 1;

    for (int i = 0; i < n; i++){
        if (used[i]) continue;
        cnt = 0;
        dfs(i);
        if (cnt == 1) sum += 1;
        else sum += (cnt + 1) / 2;
    }
    cout << sum;
    //system("pause");
}
